package io.gitlab.jfronny.quickmeth;

import net.fabricmc.api.ModInitializer;
import net.minecraft.util.math.noise.OctavePerlinNoiseSampler;
import net.minecraft.util.math.noise.OctaveSimplexNoiseSampler;
import net.minecraft.util.math.noise.PerlinNoiseSampler;
import net.minecraft.util.math.noise.SimplexNoiseSampler;
import net.minecraft.world.gen.SimpleRandom;

import java.util.List;

public class QuickMethMain implements ModInitializer {
    @Override
    public void onInitialize() {
        // Random mess to test most noise functions
        SimpleRandom sr = new SimpleRandom(1024);
        PerlinNoiseSampler pns = new PerlinNoiseSampler(sr);
        SimplexNoiseSampler sns = new SimplexNoiseSampler(sr);
        List<Integer> octaves = List.of(-1, -2, -3);
        OctavePerlinNoiseSampler opns = new OctavePerlinNoiseSampler(sr, octaves);
        OctaveSimplexNoiseSampler osns = new OctaveSimplexNoiseSampler(sr, octaves);

        System.out.println(sns.sample(sns.sample(sr.nextDouble(), sr.nextDouble()),
                pns.sample(opns.sample(sr.nextDouble(), sr.nextDouble(), sr.nextDouble()),
                        opns.sample(sr.nextDouble(), sr.nextDouble(), sr.nextDouble(), sr.nextDouble()), sr.nextDouble()),
                pns.sampleDerivative(osns.sample(sr.nextDouble(), sr.nextDouble(), true),
                        osns.sample(osns.sample(sr.nextDouble(), sr.nextDouble(), false),
                                sr.nextDouble(), sr.nextDouble(), sr.nextDouble()),
                        sr.nextDouble(),
                        new double[] {sr.nextDouble(), sr.nextGaussian(), sr.nextDouble()})));
    }
}
