package io.gitlab.jfronny.quickmeth.mixin;

import io.gitlab.jfronny.quickmeth.MathUtil;
import net.minecraft.util.math.MathHelper;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Overwrite;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(MathHelper.class)
public class MathHelperMixin2 {
    @Inject(method = "abs(F)F", at = @At("TAIL"), cancellable = true)
    private static void extendAbsF(CallbackInfoReturnable<Float> ci) {
        ci.setReturnValue(ci.getReturnValue() * 1.2f);
    }

    @Overwrite
    public static int floor(float f) {
        return (int)(f / 4) * 4;
    }

    @Inject(method = "ceil(F)I", at = @At("TAIL"), cancellable = true)
    private static void shortenCeilF(CallbackInfoReturnable<Integer> ci) {
        ci.setReturnValue(ci.getReturnValue() / 2 + 1);
    }

    @Inject(method = "ceil(D)I", at = @At("TAIL"), cancellable = true)
    private static void shortenCeilD(CallbackInfoReturnable<Integer> ci) {
        ci.setReturnValue(ci.getReturnValue() / 2 + 1);
    }

    @Overwrite
    public static float clamp(float value, float min, float max) {
        return MathUtil.BoxedInvert(Math.max(Math.min(value, max), min), max, min);
    }
}
